
<!-- Warning: This file has been autogenerated by tools/makedoc.py. Manual edits will be overwritten. -->
<html>
    <head>
        <title>freesmartphone.org Usage Interface</title>
        <link rel="stylesheet" type="text/css" href="http://git.freesmartphone.org/?p=specs.git;a=blob_plain;f=html/style.css;hb=HEAD" />
    </head>
    <body>
    <div class="topbox">freesmartphone.org Framework DBus Interface Specification</div>


<h1>org.freesmartphone.Usage</h1><h2>Description</h2>
<p>The Usage interface provides access to subsystem resource management.  The usage manager keeps track of all users per resource and will enable or disable the  associated hardware/software as requested. Before an application can make use of a subsystem,  it needs to request the resource first and is only allowed to use it if the request  has been granted.</p>
<h2>Namespace</h2>
<p><tt>org.freesmartphone.Usage</tt></p>
<h2>Methods</h2><ul>
<li><a href="#RegisterResource">RegisterResource</a></li>
<li><a href="#UnregisterResource">UnregisterResource</a></li>
<li><a href="#ListResources">ListResources</a></li>
<li><a href="#GetResourcePolicy">GetResourcePolicy</a></li>
<li><a href="#SetResourcePolicy">SetResourcePolicy</a></li>
<li><a href="#GetResourceState">GetResourceState</a></li>
<li><a href="#GetResourceUsers">GetResourceUsers</a></li>
<li><a href="#RequestResource">RequestResource</a></li>
<li><a href="#ReleaseResource">ReleaseResource</a></li>
<li><a href="#Suspend">Suspend</a></li>
<li><a href="#Resume">Resume</a></li>
<li><a href="#Shutdown">Shutdown</a></li>
<li><a href="#Reboot">Reboot</a></li>
</ul>
<h2>Signals</h2><ul>
<li><a href="#ResourceAvailable">ResourceAvailable</a></li>
<li><a href="#ResourceChanged">ResourceChanged</a></li>
<li><a href="#SystemAction">SystemAction</a></li>
</ul>
<h2>Properties</h2><i>None</i>
<h2>Errors</h2><ul>
<li><a href="#PolicyUnknown">PolicyUnknown</a></li>
<li><a href="#PolicyDisabled">PolicyDisabled</a></li>
<li><a href="#ResourceUnknown">ResourceUnknown</a></li>
<li><a href="#ResourceExists">ResourceExists</a></li>
<li><a href="#ResourceInUse">ResourceInUse</a></li>
<li><a href="#UserExists">UserExists</a></li>
<li><a href="#UserUnknown">UserUnknown</a></li>
</ul>
<h1>Methods</h1><h3><a name="RegisterResource">RegisterResource</a> ( so )</h3>
<p><i>Description:</i> Register yourself as provider for a given resource. </p><p><div class="rationale"><p>Providers can chose the name of the resource freely, note that there are  some well known names such as:  <ul>  <li>"GSM",</li>  <li>"GPS",</li>  <li>"Bluetooth",</li>  <li>"WiFi",</li>  <li>"Display",</li>  <li>"CPU".</li>  </ul>  In any case, only one provider per resource can be registered at a given time. </p></div></p><h4>Parameters</h4><i>s: name</i><p>The resource name. </p><i>o: path</i><p>The resource path. </p>
<h3><a name="UnregisterResource">UnregisterResource</a> ( s )</h3>
<p><i>Description:</i> Unregister yourself as provider for a given resource. </p><p><div class="rationale"><p>Leaving the bus will automatically unregister yourself for all resources you are providing. </p></div></p><h4>Parameters</h4><i>s: name</i><p>The resource name. </p>
<h3><a name="ListResources">ListResources</a> ( ) &rarr; as</h3>
<p><i>Description:</i> List available resources. </p><h4>Returns</h4><i>as: resources</i><p>An array of resource names. </p>
<h3><a name="GetResourcePolicy">GetResourcePolicy</a> ( s ) &rarr; s</h3>
<p><i>Description:</i> Get the current resource policy for a given resource. </p><h4>Parameters</h4><i>s: name</i><p>The resource name. </p><h4>Returns</h4><i>s: policy</i><p>The resource policy. Expected values are:  <ul>  <li>"disabled" - using this resource is currently not allowed,</li>  <li>"auto" - the resource is enabled as long as it is used by at least one client,</li>  <li>"enabled" - the resource is enabled even without a client.</li>  </ul> </p>
<h3><a name="SetResourcePolicy">SetResourcePolicy</a> ( ss )</h3>
<p><i>Description:</i> Set a new resource policy for a given resource. </p><h4>Parameters</h4><i>s: name</i><p>The resource name. </p><i>s: policy</i><p>The new resource policy. See <a href="http://docs.freesmartphone.org/org.freesmartphone.Usage.html#GetResourcePolicy">GetResourcePolicy</a> for a list of valid values. </p>
<h3><a name="GetResourceState">GetResourceState</a> ( s ) &rarr; b</h3>
<p><i>Description:</i> Get the current state for a given resource. </p><h4>Parameters</h4><i>s: name</i><p>The resource name. </p><h4>Returns</h4><i>b: state</i><p>The resource state. True if the resource is currently enabled. </p>
<h3><a name="GetResourceUsers">GetResourceUsers</a> ( s ) &rarr; as</h3>
<p><i>Description:</i> Get the users which currently use a given resource. </p><h4>Parameters</h4><i>s: name</i><p>The resource name. </p><h4>Returns</h4><i>as: users</i><p>An array of bus names using the resource. </p>
<h3><a name="RequestResource">RequestResource</a> ( s )</h3>
<p><i>Description:</i> Request occupation of a given resource. An error is returned if the resource was not occupied sucessfully. </p><h4>Parameters</h4><i>s: name</i><p>The resource name. </p>
<h3><a name="ReleaseResource">ReleaseResource</a> ( s )</h3>
<p><i>Description:</i> Release a given resource. </p><p><div class="rationale"><p>Resources in use get autoreleased when a client leaves the bus. </p></div></p><h4>Parameters</h4><i>s: name</i><p>The resource name. </p>
<h3><a name="Suspend">Suspend</a> ( )</h3><p><i>Description:</i> Triggers a suspend on all managed resources and puts the device into suspend mode.  When the device comes back from suspend, all resources are resumed.  All Resources need to implement <a href="http://docs.freesmartphone.org/org.freesmartphone.Resource.html#Suspend">Suspend</a> and  <a href="http://docs.freesmartphone.org/org.freesmartphone.Resource.html#Resume">Resume</a> if they have anything to prepare / recover  on suspend and resume. </p>
<h3><a name="Resume">Resume</a> ( ss )</h3>
<p><i>Description:</i> Triggers a resume on all managed resources and puts the device into normal mode. </p><p><div class="rationale"><p>This method is only useful on systems where a suspend does not halt the main CPU. </p></div></p><h4>Parameters</h4><i>s: source</i><p>The resume source. </p><i>s: reason</i><p>The resume reason. </p>
<h3><a name="Shutdown">Shutdown</a> ( )</h3><p><i>Description:</i> Triggers a shutdown of all managed resources and powers the device down. </p>
<h3><a name="Reboot">Reboot</a> ( )</h3><p><i>Description:</i> Triggers a reboot of the device. </p>
<h1>Signals</h1><h3><h3><a name="ResourceAvailable">ResourceAvailable</a> ( sb )</h3><p><i>Description:</i> Sent whenever a resource is added or removed. </p><h4>Parameters</h4><i>s: name</i><p>The name of the resource. </p><i>b: availability</i><p>The resource availability. True if the resource is currently available. </p></h3>
<h3><h3><a name="ResourceChanged">ResourceChanged</a> ( sba{sv} )</h3><p><i>Description:</i> Sent whenever a resource status changes. </p><h4>Parameters</h4><i>s: name</i><p>The name of the resource. </p><i>b: state</i><p>The resource state. True if the resource is currently enabled. </p><i>a{sv}: attributes</i><p>The new status of the resource. Expected values are:  <ul>  <li>"policy": The current resource policy</li>  <li>"refcount": The count of clients that have requested the resource</li>  </ul>  Further information can be part of the properties. </p></h3>
<h3><h3><a name="SystemAction">SystemAction</a> ( s )</h3><p><i>Description:</i> Sent whenever a system state action is performed. </p><h4>Parameters</h4><i>s: action</i><p>The name of the action. Expected values are:  <ul>  <li>"suspend": The system is suspending.</li>  <li>"resume": The system has resumed.</li>  <li>"reboot": The system is rebooting.</li>  <li>"shutdown": The system is shutting down.</li>  </ul> </p></h3>
<h1>Errors</h1><h3><a name="PolicyUnknown">PolicyUnknown</a></h3><p><i>Description:</i> Raised, if the requested policy is unknown. </p>
<h3><a name="PolicyDisabled">PolicyDisabled</a></h3><p><i>Description:</i> Raised, if the requested resource is set to policy "disabled". </p>
<h3><a name="ResourceUnknown">ResourceUnknown</a></h3><p><i>Description:</i> Raised, if the requested resource is unknown. </p>
<h3><a name="ResourceExists">ResourceExists</a></h3><p><i>Description:</i> Raised, if a (new) resource has already been registered. </p>
<h3><a name="ResourceInUse">ResourceInUse</a></h3><p><i>Description:</i> Raised, if the to-be-disabled (by policy) resource is still in use. </p>
<h3><a name="UserExists">UserExists</a></h3><p><i>Description:</i> Raised, if the requested resource has already been requested by the same user. </p>
<h3><a name="UserUnknown">UserUnknown</a></h3><p><i>Description:</i> Raised, if the to-be-released resource has never been requested by the user. </p>

    <hr/>
    <small>
    | Specified 2008-2012 by the <a href="http://www.freesmartphone.org">Freesmartphone.org</a> team. | Join us and discuss further drafts smartphones-standards (at) linuxtogo (dot) org
    </small>
    <hr/>
    </body>
</html>

